diff options
author | Stefano Lattarini <stefano.lattarini@gmail.com> | 2012-08-30 14:13:12 +0200 |
---|---|---|
committer | Jim Meyering <meyering@redhat.com> | 2012-08-30 18:55:59 +0200 |
commit | 9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch) | |
tree | ea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/misc/nohup.sh | |
parent | 00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff) | |
download | coreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz |
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300
lines to ~3000), but will allow further simplifications in future
changes.
* tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'.
(PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to
$(LOG_COMPILER) for the time being.
(TESTS, root_tests): Adjust as described.
* All tests: Rename as described.
Diffstat (limited to 'tests/misc/nohup.sh')
-rwxr-xr-x | tests/misc/nohup.sh | 121 |
1 files changed, 121 insertions, 0 deletions
diff --git a/tests/misc/nohup.sh b/tests/misc/nohup.sh new file mode 100755 index 000000000..76f676d81 --- /dev/null +++ b/tests/misc/nohup.sh @@ -0,0 +1,121 @@ +#!/bin/sh +# test nohup + +# Copyright (C) 2003-2012 Free Software Foundation, Inc. + +# This program is free software: you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation, either version 3 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program. If not, see <http://www.gnu.org/licenses/>. + +. "${srcdir=.}/init.sh"; path_prepend_ ../src +print_ver_ nohup + + +nohup sh -c 'echo stdout; echo stderr 1>&2' 2>err || fail=1 + +# Be careful. The results of the above nohup command +# change depending on whether stdin and stdout are redirected. +if test -t 1; then + test "$(cat nohup.out)" = stdout || fail=1 + if test -t 0; then + echo 'nohup: ignoring input and appending output to 'nohup.out'\' + else + echo 'nohup: appending output to 'nohup.out'\' + fi >exp || fail=1 +else + # Here it should not even exist. + test -f nohup.out && fail=1 + if test -t 0; then + echo 'nohup: ignoring input' >exp + else + rm -f exp + fi || fail=1 +fi +echo 'stderr' >> exp || fail=1 + +compare exp err || fail=1 +rm -f nohup.out err exp +# ---------------------- + +# Be careful. The results of the following nohup command +# change depending on whether stderr is redirected. +nohup sh -c 'echo stdout; echo stderr 1>&2' >out || fail=1 +if test -t 2; then + test "$(cat out|tr '\n' -)" = stdout-stderr- || fail=1 +else + test "$(cat out|tr '\n' -)" = stdout- || fail=1 +fi +# It must *not* exist. +test -f nohup.out && fail=1 +rm -f nohup.out err +# ---------------------- + +# Bug present through coreutils 8.0: failure to print advisory message +# to stderr must be fatal. Requires stdout to be terminal. +if test -w /dev/full && test -c /dev/full; then +( + exec >/dev/tty + test -t 1 || exit 0 + nohup echo hi 2> /dev/full + test $? = 125 || fail=1 + test -f nohup.out || fail=1 + test -s nohup.out && fail=1 + rm -f nohup.out + exit $fail +) || fail=1 +fi + +nohup no-such-command 2> err +errno=$? +if test -t 1; then + test $errno = 127 || fail=1 + # It must exist. + test -f nohup.out || fail=1 + # It must be empty. + test -s nohup.out && fail=1 +fi + +cat <<\EOF > exp || fail=1 +nohup: appending output to 'nohup.out' +nohup: cannot run command 'no-such-command': No such file or directory +EOF +# Disable these comparisons. Too much variation in 2nd line. +# compare exp err || fail=1 +rm -f nohup.out err exp +# ---------------------- + +touch k; chmod 0 k +nohup ./k 2> err +errno=$? +test $errno = 126 || fail=1 +if test -t 1; then + # It must exist. + test -f nohup.out || fail=1 + # It must be empty. + test -s nohup.out && fail=1 +fi + +cat <<\EOF > exp || fail=1 +nohup: appending output to 'nohup.out' +nohup: cannot run command './k': Permission denied +EOF +# Disable these comparisons. Too much variation in 2nd line. +# compare exp err || fail=1 + +# Make sure it fails with exit status of 125 when given too few arguments, +# except that POSIX requires 127 in this case. +nohup >/dev/null 2>&1 +test $? = 125 || fail=1 +POSIXLY_CORRECT=1 nohup >/dev/null 2>&1 +test $? = 127 || fail=1 + +Exit $fail |